Page MenuHomePhabricator

Allow admins to forcibly set a mentor's status
Closed, ResolvedPublicFeature

Description

Feature summary (what you would like to be able to do and where):
Local admins should be allowed to forcibly set a mentor's status and quit their mentorship.

Use case(s) (list the steps that you performed to discover that problem, and describe the actual underlying problem which you want to solve. Do not describe only a solution):
If a mentor become inactive (for a short/long time) and forgot to set their status as "leave" (or even quit their mentorship), newly-assigned mentee would have trouble getting help and assistance. Currently we have action=growthsetmentorstatus to set self status as leave or active, and I thought it would be great to develop some new API to forcibly change mentor's status.

Benefits (why should this be implemented?):
Benefit assigned mentee, let them not be assigned to inactive mentors.

Event Timeline

Thanks for the feature idea. Cc'ing @KStoller-WMF to think about prioritization.

@Urbanecm_WMF / @Trizek-WMF

I know we have this work in progress: T264343 , which I believe includes allowing admins to remove a mentor from Mentorship. Do we also want to consider allowing admins to set a mentor's status as Away?
Would that be minimal work, or a large effort?

Thanks for the ping @KStoller-WMF! Allowing admins to set other mentor's status to Away (or back to Active) is definitely possible, and it should be reasonably easy to do so. Personally, I think we should first work on the 1.0 version of T264343: Have a special page for mentors to sign up (ie. without the ability to edit information about the other mentors). As that project approaches its completion, we can decide (based on wider community feedback) whether to implement admin editing as well, or whether to do that later.

T264343 will make admins able to fully remove mentors.

I think it should be in v1.0, as we already had request to remove mentors from mentors' lists.

I think it should be in v1.0, as we already had request to remove mentors from mentors' lists.

I meant to say that I think removal should be a part of v1.0, but editing (ie. forced change of someone else's active/away, or someone else's description) can wait for a future version. Would that be okay with you?

I think it should be in v1.0, as we already had request to remove mentors from mentors' lists.

I meant to say that I think removal should be a part of v1.0, but editing (ie. forced change of someone else's active/away, or someone else's description) can wait for a future version. Would that be okay with you?

Allowing admins to somehow remove someone from the list is what I had in mind. :)

Urbanecm_WMF renamed this task from Allow admins to forcibly set a mentor's status and quit their mentorship to Allow admins to forcibly set a mentor's status.Jul 5 2022, 8:33 PM

This was highlighted during the 2022-09-06 mentorship meeting as one of the priorities to work on soon (likely together with T312181).

Change 831134 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] SpecialManageMentors: Refactor form handling

https://gerrit.wikimedia.org/r/831134

Urbanecm_WMF changed the task status from Open to In Progress.Sep 9 2022, 6:32 PM
Urbanecm_WMF claimed this task.
Urbanecm_WMF triaged this task as Medium priority.

Change 831134 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] SpecialManageMentors: Refactor form handling

https://gerrit.wikimedia.org/r/831134

Change 832521 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[mediawiki/extensions/GrowthExperiments@master] ManageMentorsEditMentor: Allow admins to change mentor's status

https://gerrit.wikimedia.org/r/832521

Change 832521 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] ManageMentorsEditMentor: Allow admins to change mentor's status

https://gerrit.wikimedia.org/r/832521

Urbanecm_WMF changed the task status from In Progress to Open.Sep 29 2022, 10:05 AM

Checked on wmf.6 - Special:ManageMentors - no issues found.
The screenshots are for illustrations only.

Screen Shot 2022-10-20 at 9.49.09 AM.png (1×2 px, 404 KB)
Screen Shot 2022-10-20 at 9.49.22 AM.png (1×1 px, 123 KB)
Screen Shot 2022-10-20 at 10.04.15 AM.png (618×1 px, 61 KB)

non-Admin view of Special:ManageMentors

Screen Shot 2022-10-20 at 10.08.28 AM.png (1×2 px, 329 KB)

@Urbanecm

(1) On testwiki wmf.6 removing a mentor (click on Remove on Special:ManageMentors page and then Submit) doesn't re-assign mentees to another mentor.

Steps

  • Zilant18 is a mentor for Zilant1
  • Admin removed Zilant18 from the mentor list
  • Zilant18 doesn't see the Mentor dashboard (only Assign as a mentor) - this action is immediate
  • Zilant1 still sees Zilant18 as an assigned mentor after >3 hours after the action

(2) (just a question) Actions performed on Special:ManageMentors page are not recorded in Special:Log? For GrowthExperiments I saw only the following actions

Screen Shot 2022-10-20 at 10.05.39 AM.png (1×1 px, 199 KB)
.
Should editing/removing mentors be logged?

(3) Attribution of edits - when a mentor does some status changing actions on Special:MentorDashboard, those actions are recorded as editing MediaWiki:GrowthMentors.json, but often mentors do not have editing rights for the page

Screen Shot 2022-10-20 at 10.42.38 AM.png (730×1 px, 279 KB)
Screen Shot 2022-10-20 at 10.42.13 AM.png (1×2 px, 327 KB)

(1) On testwiki wmf.6 removing a mentor (click on Remove on Special:ManageMentors page and then Submit) doesn't re-assign mentees to another mentor.

Steps

  • Zilant18 is a mentor for Zilant1
  • Admin removed Zilant18 from the mentor list
  • Zilant18 doesn't see the Mentor dashboard (only Assign as a mentor) - this action is immediate
  • Zilant1 still sees Zilant18 as an assigned mentor after >3 hours after the action

Thanks for noticing this bug! Split into T321382: When a mentor is removed via Speical:ManageMentors, no mentees are reassigned and uploaded a patch to fix it.

(2) (just a question) Actions performed on Special:ManageMentors page are not recorded in Special:Log? For GrowthExperiments I saw only the following actions

Screen Shot 2022-10-20 at 10.05.39 AM.png (1×1 px, 199 KB)
.
Should editing/removing mentors be logged?

They're logged in a similar way like Special:EditGrowthconfig changes: in the history of the MediaWiki:GrowthMentors.json page. We definitely can log them under Special:Log as well -- do you think that'd be helpful?

(3) Attribution of edits - when a mentor does some status changing actions on Special:MentorDashboard, those actions are recorded as editing MediaWiki:GrowthMentors.json, but often mentors do not have editing rights for the page

Screen Shot 2022-10-20 at 10.42.38 AM.png (730×1 px, 279 KB)
Screen Shot 2022-10-20 at 10.42.13 AM.png (1×2 px, 327 KB)

Yes, that is intended; I think it's a reasonable solution to ensure logging plus some attribution (a system account would probably be counter-intuitive).

Thanks, @Urbanecm! Re (2) and (3) - yes, it's hard to say what would be the best way to log ManageMentor actions, for now I think it's ok to keep it as part of MediaWiki:GrowthMentors.json.

Since the issue with re-assigning mentees after removing a mentor is captured in T321382, the scope of this task is done, closing as Resolved.